

inline double dabs(double d) {
    return (d > 0) ? d : -d;
}

//Gaussian Function
inline double gauss(double dx, double dy, double dsig) {
  double dist = dx-dy;
  return exp(-(dist*dist)*dsig);
}
//2D Gaussian Filter (Separatable Implementation)
//Summing up All (input->sx*input->sy)

 void GaussianFilterSeparateAll(Image *input,double *sigma,Image *output){
    
    
    int i,j,k;
    double sigX = 0.5/(sigma[0]*sigma[0]);
    double sigY = 0.5/(sigma[1]*sigma[1]);
    //double coef = 1.0/(2.0*PI*sigma[0]*sigma[1]);
    double dx,dy;
    Image *tmp = new Image(input->sx,input->sy);
    Image *tmp2 = new Image(input->sx,input->sy);
    double *wX = new double[input->sx];
    double *wY = new double[input->sy];
    for(j=0;j<input->sx;j++){
      dx = ((double)(j));
      wX[j] = gauss(dx,0.0,sigX);
    }
    for(j=0;j<input->sy;j++){
      dx = ((double)(j));
      wY[j] = gauss(dx,0.0,sigY);
    }
    
    for(i=0;i<input->sy;i++){
      for(j=0;j<input->sx;j++){
	
	tmp->img[i][j]=0.0;
	tmp2->img[i][j]=0.0;
	for(k=0;k<input->sx;k++){
	  
	  double dw = wX[abs(j-k)];
	  tmp->img[i][j] += dw*input->img[i][k];
	  tmp2->img[i][j] += dw;
	}
      }
    }
    for(i=0;i<input->sx;i++){
      for(j=0;j<input->sy;j++){
	
	output->img[j][i]=0.0;
	double dsum=0.0;
	for(k=0;k<input->sy;k++){
	
	  double dw = wY[abs(j-k)];
	  output->img[j][i] += dw*tmp->img[k][i];
	  dsum += dw*tmp2->img[k][i];
	}
	if(dsum<=0.0)dsum=1.0;
	output->img[j][i] /= dsum;
      }
    }
    delete [] wX;
    delete [] wY;
    delete tmp2;
    delete tmp;
 }


