//2008 2/27 newest

#define INF 1e100
//#define IRC 6
#define K1 1.089999
#define PI 3.141592653589793238462643383279502884197
#define NE 2.718281828459045235360287471352662497757
//typedef long long int llint;
//typedef long double lldouble;
typedef int llint;
typedef double lldouble;
class gaussfgt1D{
 public:
  lldouble *sgx;
  lldouble sourcescale;
  
  gaussfgt1D(){ 
    sgx=NULL; sourcescale=1.0;
  }
  virtual ~gaussfgt1D(){ 
    if(sgx!=NULL)free(sgx);
  }
  inline lldouble dmax(lldouble a, lldouble b) {
    return (a > b) ? a : b;
  }
  
  inline lldouble dmin(lldouble a, lldouble b) {
    return (a < b) ? a : b;
  }
  
  inline lldouble dabs(lldouble d) {
    return (d > 0) ? d : -d;
  }
  
  inline lldouble square(lldouble d) {
    return d * d;
  }
  
  llint getPWEK(lldouble *weight,lldouble eps,int natoms,lldouble radii){
      // X. Wan & G. E.Karniadakis [JCP2006]
    llint i,ip;
    //lldouble qsum=0.0;
    lldouble val;
    lldouble Kconst = K1*pow((2.0*PI),-0.25);
    //for(i=0;i<natoms;i++)qsum+=((lldouble)(fabs(weight[i])));
    //if(qsum<=0.0)qsum=((lldouble)(1.0));
    //qsum *= Kconst;
    for(ip=1;;ip++){
      
      lldouble rp=(radii*sqrt(NE/ip));
      
      //val = qsum*pow(ip,-0.25)*(pow(rp,ip)/(1.0-rp));
      val = Kconst*pow(ip,-0.25)*(pow(rp,ip)/(1.0-rp));
      
      if(val<((lldouble)(eps))){
	break;
      }
    }
    
    return ip;
  }
  /*
  llint getPWEK(lldouble *weight,lldouble eps,int natoms,lldouble radii){
      // X. Wan & G. E.Karniadakis [JCP2006]
    llint i,ip;
    lldouble val;
    lldouble Kconst = K1*pow((2.0*PI),-0.25);
    for(ip=1;;ip++){
      
      lldouble rp=(radii*sqrt(NE/ip));
      
      
      val = (pow(rp,ip)/(1.0-rp));
      
      if(val<((lldouble)(eps))){
	break;
      }
    }
    
    return ip;
  }
    */
// ******************************************************************
  void gausst(lldouble* xat,lldouble* str, llint natoms,lldouble* pot,lldouble delta,lldouble tol,int IRC) {
  llint i, j, nside, nmax, kdis, nfmax, nlmax, ntbox;
  lldouble boxdim, r=0, z;
  lldouble radii=0.5;
  
  llint* iloc, *itofst, *itradr, *ibox;
  lldouble* center, **locexp;    
  
  boxdim = radii*sqrt(2.0*delta);
  nmax = natoms;
  nside = ((llint)(1.0/boxdim))+1;
  
  llint k, d;
  llint nterms = getPWEK(str,tol,natoms,radii)+1;
  
  kdis = IRC;
  //printf("nterms = %d, nside = %d, kdis = %d\n",nterms,nside,kdis);
    
  nfmax = nterms + 2;
  nlmax = nterms + 2;
  lenchk(nside, xat, natoms, nterms, nmax, &iloc, &ibox, &itofst,&itradr, &locexp, &center, &ntbox);
  
  for(j=0;j<natoms;j++)pot[j]=0.0;
  
  
  gafexp(xat,str,natoms,delta,nside,nterms,tol,iloc,ntbox,nfmax,nlmax,pot,kdis,ibox,itradr,itofst,center,locexp);
  
  gaeval(xat,pot,natoms,locexp,nterms,ibox,center,delta,iloc,nlmax,nside,itofst,itradr);
    
  freestuff(iloc, ibox, itofst, itradr, locexp, center, nterms, ntbox);
  return;
}
 


 

// ******************************************************************
 inline void gdir(lldouble xp,lldouble* xat,llint natoms, lldouble* str, lldouble* dpot, lldouble delta){
   lldouble x;
   llint j;
   for(j=0;j<natoms;j++){
     x = xp - xat[j];
     (*dpot) += exp(-(x*x)/delta)*str[j];
   }
 }
 
 // ******************************************************************
 void gamval(lldouble* ffexp, llint nterms, lldouble cent, lldouble xpollint,lldouble* pot, lldouble delta) {
   llint i,j,k;
   lldouble facx,x,x2,potinc,hexpx2,hexpx1,hexpx0;
   lldouble* hexpx;
   x = (xpollint - cent)/sqrt(delta);
   x2 = 2.0*x;
   facx = exp(-x*x);
   hexpx0 = facx;
   hexpx1 = x2*facx;
   potinc = 0.0;
   potinc +=  facx*ffexp[0];
   potinc +=  x2*facx*ffexp[1];
   for(i=2;i<(nterms+1);i++){
     hexpx2 = x2*hexpx1 - 2*i*hexpx0;
     potinc +=  hexpx2*ffexp[i];
     if(i>=nterms)break;
     hexpx0 = hexpx1;
     hexpx1 = hexpx2;
   }
   (*pot) += potinc;
 }
 
 // ******************************************************************
 void gamkxp(lldouble cent, lldouble* xatoms,lldouble* str, llint ninbox, lldouble* ffexp, llint nterms,lldouble delta) {
   llint i,j,k;
   lldouble dsq,x,xp;
   for(i=0;i<(nterms+1);i++)ffexp[i] = 0.0;
   dsq = 1.0/sqrt(delta);
   for(i=0;i<ninbox;i++) {
     x = (xatoms[i] - cent)*dsq;
     xp = str[i];
     for (j=0;j<(nterms+1);j++) {
       ffexp[j] += xp;
       xp *= (x/(j+1));
     } 
   }
   return;
 }
 
 
// ******************************************************************
void galkxp(lldouble cent,lldouble xp,lldouble charge, lldouble* b, llint nterms, lldouble delta){ 
  llint i,l;
  lldouble x,x2,facx,facs,hexpx0,hexpx1,hexpx2;
  x = (cent - xp)/sqrt(delta);
  x2 = 2.0*x;
  facx = exp(-x*x)*charge;
  hexpx0 = facx;
  hexpx1 = x2*facx;
  facs = 1.0;
  for(l=0;l<nterms+1;l++){
    hexpx2 =x2*hexpx1 - 2*l*hexpx0;
    hexpx2 *= facs;
    b[l] = hexpx2;
    facs = -1*facs/(l+1.0);
    if(l>=nterms)break;
    hexpx0 = hexpx1;
    hexpx1 =hexpx2;
  }
  return;
}
// ******************************************************************
void gaeval(lldouble* xtarg,lldouble* pot,
	    llint ntarg, lldouble** locexp, llint nterms, llint* ibox,
	    lldouble* center, lldouble delta, llint* iloc, llint nlmax, llint
	    nside, llint* itofst, llint* itradr) {
  llint i, k, jt,inoff, jadr, ninbox;
  for(i=0;i<nside;i++){
    inoff = itofst[i];
    ninbox = itofst[i+1] - inoff;
    if(ninbox > nlmax){
      jadr = iloc[i];
      for(k=0;k<ninbox;k++){
	jt = itradr[inoff+k];
	galval(locexp[jadr],nterms,center[i],xtarg[jt],&pot[jt],delta);
      }
    }
  }
  return;
}
 

// ******************************************************************
 void gafexp(lldouble* xat,lldouble* str,llint natoms,lldouble delta,llint nside,llint nterms, lldouble tol,llint* iloc,llint ntbox,llint nfmax,llint nlmax,lldouble* pot,llint kdis,llint* ibox,llint* itradr,llint* itofst,lldouble* center, lldouble** locexp){
   lldouble* xatoms,*charg2;
   lldouble cent,xp;
   lldouble* ffexp, *b;
   llint i, j, k, l, maxpts, ioff, iadr, inoff, nnbors, ninnbr, jt, iadloc, ninbox;
   llint*ioffst, *nbors;
   maxpts = natoms;
   ioffst = (llint*) malloc((nside+1) * sizeof(llint));
   nbors = (llint*) malloc(nside * sizeof(llint));
   xatoms = (lldouble*) malloc(natoms * sizeof(lldouble)); 
   charg2  = (lldouble*) malloc(natoms * sizeof(lldouble)); 
   ffexp = (lldouble*) malloc((nterms+1) * sizeof(lldouble));
   b = (lldouble*) malloc((nterms+1) * sizeof(lldouble));
   assign(nside,xat,str,xatoms,charg2,ioffst,ibox, natoms, center,itradr, itofst); 
   // zero the local expansions
   for(i=0;i<ntbox;i++)
     for(j=0;j<(nterms+1);j++)locexp[i][j] = 0.0;
   for(i=0;i<nside;i++){
     ioff = ioffst[i];
     ninbox = ioffst[i+1] - ioff;
    if((ninbox<=nfmax)&&(ninbox>0)){
      // No far-field expansion
      mknbor(i,nbors,&nnbors,nside,kdis);
      for(j=0;j<nnbors;j++){
	iadr = nbors[j];
	inoff = itofst[iadr];
	ninnbr = itofst[iadr+1]-inoff;
	if (ninnbr <= nlmax) {
	  // Direct llinteraction
	  for (k=0;k<ninnbr;k++) {
	    jt = itradr[inoff+k];
	    xp = xat[jt];
	    gdir(xp,&xatoms[ioff],ninbox, &charg2[ioff],&pot[jt], delta);
	  }
	}else{
	  // Sources in neighbors shifted to taylor series
	  cent = center[iadr];
	  iadloc = iloc[iadr];
	  for(k=0;k<ninbox;k++) {
	    galkxp(cent,xatoms[ioff+k],charg2[ioff+k],b,nterms,delta);
	    addexp(b,locexp[iadloc],nterms); 		    
	  }
	}
      }
    }else if((ninbox>nfmax)&&(ninbox>0)){
      // create far-field expansion
      cent = center[i];
      gamkxp(cent,&xatoms[ioff],&charg2[ioff],ninbox,ffexp,nterms,delta);
      mknbor(i,nbors,&nnbors,nside,kdis); 
      for(j=0;j<nnbors;j++) {
	iadr = nbors[j];
	inoff = itofst[iadr];
	ninnbr = itofst[iadr+1] - inoff;
	if(ninnbr <= nlmax) { 
	  // too few targets, shift to local
	  for(k=0;k<ninnbr;k++) {
	    jt = itradr[inoff+k];
	    xp = xat[jt];
	    gamval(ffexp,nterms,cent,xp,&pot[jt],delta);
	  }
	}else{
	  gshift(ffexp, cent,center[iadr],b,nterms,delta); 
	  iadloc = iloc[iadr];
	  addexp(b,locexp[iadloc],nterms);
	}
      }
    }
   }
   
   
   // free ffexp, b, temp1, temp2
   free(ffexp);
   free(b);    
   free(xatoms);
   free(charg2);
   free(ioffst);
  free(nbors);
  return;
 }
 // ******************************************************************
 void gafexp(lldouble* xat,lldouble* xtarg,lldouble* str,llint natoms,llint ntarg,lldouble delta,llint nside,llint nterms, lldouble tol,llint* iloc,llint ntbox,llint nfmax,llint nlmax,lldouble* pot,llint kdis,llint* ibox,llint* itradr,llint* itofst,lldouble* center, lldouble** locexp){
   lldouble* xatoms,*charg2;
   lldouble cent,xp;
   lldouble* ffexp, *b;
   llint i, j, k, l, maxpts, ioff, iadr, inoff, nnbors, ninnbr, jt, iadloc, ninbox;
   llint*ioffst, *nbors;
   if (natoms>ntarg) {
        maxpts = natoms;
    } else {
        maxpts = ntarg;
    }

   ioffst = (llint*) malloc((nside+1) * sizeof(llint));
   nbors = (llint*) malloc(nside * sizeof(llint));
   xatoms = (lldouble*) malloc(natoms * sizeof(lldouble)); 
   charg2  = (lldouble*) malloc(natoms * sizeof(lldouble)); 
   ffexp = (lldouble*) malloc((nterms+1) * sizeof(lldouble));
   b = (lldouble*) malloc((nterms+1) * sizeof(lldouble));
   assign(nside,xat,xtarg,str,xatoms,charg2,ioffst,ibox, natoms,ntarg, center,itradr, itofst); 
   // zero the local expansions
   for(i=0;i<ntbox;i++)
     for(j=0;j<(nterms+1);j++)locexp[i][j] = 0.0;
   for(i=0;i<nside;i++){
     ioff = ioffst[i];
     ninbox = ioffst[i+1] - ioff;
    if((ninbox<=nfmax)&&(ninbox>0)){
      // No far-field expansion
      mknbor(i,nbors,&nnbors,nside,kdis);
      for(j=0;j<nnbors;j++){
	iadr = nbors[j];
	inoff = itofst[iadr];
	ninnbr = itofst[iadr+1]-inoff;
	if (ninnbr <= nlmax) {
	  // Direct llinteraction
	  for (k=0;k<ninnbr;k++) {
	    jt = itradr[inoff+k];
	    xp = xtarg[jt];
	    gdir(xp,&xatoms[ioff],ninbox, &charg2[ioff],&pot[jt], delta);
	  }
	}else{
	  // Sources in neighbors shifted to taylor series
	  cent = center[iadr];
	  iadloc = iloc[iadr];
	  for(k=0;k<ninbox;k++) {
	    galkxp(cent,xatoms[ioff+k],charg2[ioff+k],b,nterms,delta);
	    addexp(b,locexp[iadloc],nterms); 		    
	  }
	}
      }
    }else if((ninbox>nfmax)&&(ninbox>0)){
      // create far-field expansion
      cent = center[i];
      gamkxp(cent,&xatoms[ioff],&charg2[ioff],ninbox,ffexp,nterms,delta);
      mknbor(i,nbors,&nnbors,nside,kdis); 
      for(j=0;j<nnbors;j++) {
	iadr = nbors[j];
	inoff = itofst[iadr];
	ninnbr = itofst[iadr+1] - inoff;
	if(ninnbr <= nlmax) { 
	  // too few targets, shift to local
	  for(k=0;k<ninnbr;k++) {
	    jt = itradr[inoff+k];
	    xp = xtarg[jt];
	    gamval(ffexp,nterms,cent,xp,&pot[jt],delta);
	  }
	}else{
	  gshift(ffexp, cent,center[iadr],b,nterms,delta); 
	  iadloc = iloc[iadr];
	  addexp(b,locexp[iadloc],nterms);
	}
      }
    }
   }
   
   
   // free ffexp, b, temp1, temp2
   free(ffexp);
   free(b);    
   free(xatoms);
   free(charg2);
   free(ioffst);
  free(nbors);
  return;
 }
 
 
 // ******************************************************************
inline void addexp(lldouble*b, lldouble*a, llint nterms) {
  llint i;
  for(i=0;i<nterms+1;i++)a[i] += b[i];    
 }
 
// ******************************************************************
 void galval(lldouble* local, llint nterms, lldouble cent, lldouble xpollint,lldouble* pot, lldouble delta) {
   llint i;
   lldouble x, potinc;
   x = (xpollint - cent)/(sqrt(delta));
   potinc = 0.0;
   for(i=nterms;i>0;i--)potinc = (potinc + local[i])*x;
   potinc += local[0];
   *pot = potinc;
   return;
 }
 
 
 // ******************************************************************
 void assign(llint nside, lldouble* xat, lldouble* str, lldouble* xatoms,lldouble* charg2, llint* ioffst, llint* ibox, llint natoms,lldouble* center, llint* itradr, llint* itofst) {
   llint j,iadr,indx,ixh;
   lldouble h, hh;
   llint* icnt; //allocate dynamically here
   llint* icnt2; // same
   icnt = (llint*) malloc(nside * sizeof(llint));
   icnt2 = (llint*) malloc(nside * sizeof(llint));
   
   for (j=0;j<nside;j++) {
     icnt2[j] = 0;
     icnt[j] = 0;
   }
   h = 1.0/nside;
   for(j=0;j<natoms;j++){
     ixh = (llint) floor(xat[j]/h);
     if(ixh > nside - 1)ixh = nside - 1;
     if(ixh < 0)ixh = 0;
     iadr = ixh;
     icnt[iadr]++;
     ibox[j] = iadr;
   }
   itofst[0] = ioffst[0] = 0;
   for(j=1;j<nside+1;j++){
     ioffst[j] = ioffst[j-1] + icnt[j-1];
     itofst[j] = itofst[j-1] + icnt[j-1];
   }
   for(j=0;j<natoms;j++){
     iadr = ibox[j];
     indx = ioffst[iadr] + icnt2[iadr];
     xatoms[indx] = xat[j];
     charg2[indx] = str[j];
     itradr[indx] = j;
     icnt2[iadr]++;
   }
   hh = 0.5*h;
   for(j=0;j<nside;j++)center[j] = j*h + hh;
   free(icnt);
   free(icnt2);
   return;
 }
 
 // ******************************************************************
 void assign(llint nside, lldouble* xat, lldouble* xtarg, lldouble* str, lldouble* xatoms,lldouble* charg2, llint* ioffst, llint* ibox, llint natoms, llint ntarg,lldouble* center, llint* itradr, llint* itofst) {
   llint j,iadr,indx,ixh;
   lldouble h, hh;
   llint* icnt; //allocate dynamically here
   llint* icnt2; // same
   icnt = (llint*) malloc(nside * sizeof(llint));
   icnt2 = (llint*) malloc(nside * sizeof(llint));
   
   for (j=0;j<nside;j++) {
     icnt2[j] = 0;
     icnt[j] = 0;
   }
   h = 1.0/nside;
   for(j=0;j<natoms;j++){
     ixh = (llint) floor(xat[j]/h);
     if(ixh > nside - 1)ixh = nside - 1;
     if(ixh < 0)ixh = 0;
     iadr = ixh;
     icnt[iadr]++;
     ibox[j] = iadr;
   }
   itofst[0] = ioffst[0] = 0;
   for(j=1;j<nside+1;j++){
     ioffst[j] = ioffst[j-1] + icnt[j-1];
     //itofst[j] = itofst[j-1] + icnt[j-1];
   }
   for(j=0;j<natoms;j++){
     iadr = ibox[j];
     indx = ioffst[iadr] + icnt2[iadr];
     xatoms[indx] = xat[j];
     charg2[indx] = str[j];
     itradr[indx] = j;
     icnt2[iadr]++;
   }
   for (j=0;j<nside;j++) {
     icnt2[j] = 0;
     icnt[j] = 0;
   }
   for(j=0;j<ntarg;j++){
     ixh = (llint) floor(xtarg[j]/h);
     if(ixh > nside - 1)ixh = nside - 1;
     if(ixh < 0)ixh = 0;
     iadr = ixh;
     icnt[iadr]++;
     ibox[j] = iadr;
   }
   itofst[0] = 0;
   for(j=1;j<nside+1;j++){
     
     itofst[j] = itofst[j-1] + icnt[j-1];
   }
   for (j=0;j<ntarg;j++) {
        iadr = ibox[j];
        indx = itofst[iadr] + icnt2[iadr];
        itradr[indx] = j;
        icnt2[iadr]++;
   }
   hh = 0.5*h;
   for(j=0;j<nside;j++)center[j] = j*h + hh;
   free(icnt);
   free(icnt2);
   return;
 }
 
 

 // ******************************************************************
 void freestuff(llint* iloc,llint* ibox,llint* itofst,llint* itradr,lldouble** locexp,lldouble* center,llint nterms,llint ntbox){
   free(iloc);
   free(ibox);
   free(itofst);
   free(itradr);
   for(llint i=0;i<ntbox;i++)free(locexp[i]);
   free(locexp);
   free(center);
   return;
 }
 

// ******************************************************************
void gshift(lldouble* ffexp, lldouble cent1, lldouble cent2, lldouble* local, llint nterms,lldouble delta){
  
  llint i,len,alpha1,beta1;
  lldouble x,x2,sum,facx;
  lldouble* hexpx, *fac;
  hexpx = (lldouble*) malloc((2*nterms+1) * sizeof(lldouble));
  fac = (lldouble*) malloc((nterms+1) * sizeof(lldouble));
  x = (cent2-cent1)/sqrt(delta);
  x2 = 2*x;
  facx = exp(-x*x);
  hexpx[0] = facx;
  hexpx[1] = x2*facx;
  for (i=1;i<(2*nterms);i++) {
    hexpx[i+1] = x2*hexpx[i] - 2*i*hexpx[i-1];
  }
  fac[0] = 1.0;
  for(i=1;i<nterms+1;i++)fac[i] = -fac[i-1]/i;
  len = nterms+1;
  for(beta1=0;beta1<len;beta1++){
    local[beta1]= 0.0;
    for(alpha1=nterms;alpha1>=0;alpha1--)local[beta1]+=ffexp[alpha1]*hexpx[alpha1+beta1];
    local[beta1]*=fac[beta1];
  }
  free(hexpx);
  free(fac);
  return;
}
 
 
// ******************************************************************
 void mknbor(llint ibox, llint* nbors, llint* nnbors, llint nside, lldouble kdis) {
   llint i,imin, imax;
   *nnbors = 0;
   if((ibox-kdis)>0)
     imin = (llint) floor(ibox-kdis);
   else
     imin = 0;
   if ((ibox+kdis)<(nside-1))
     imax = (llint) floor(ibox + kdis);
   else
     imax = nside-1;
   for (i=imin;i<imax+1;i++) {
     nbors[*nnbors] =i;
     (*nnbors)++; 
   }
   return;
 }
 
 
 // ******************************************************************
 void lenchk(llint nside, lldouble* xtarg,llint ntarg, llint nterms, llint nmax, llint** iloc, llint** ibox,llint** itofst, llint** itradr, lldouble*** locexp, lldouble** center, llint* ntbox){
   llint i, j,ixh,iadr;
   lldouble h;
 
   *ntbox = 0;
   // allocate the arrays
   *iloc = (llint*) malloc(nside * sizeof(llint));
   *itofst = (llint*) malloc((nside+1) * sizeof(llint));
   *itradr = (llint*) malloc(ntarg * sizeof(llint));
   *ibox = (llint*) malloc(nmax * sizeof(llint));
   *center = (lldouble*) malloc(nside * sizeof(lldouble));
   h = 1.0/nside;
   for (i=0;i<nside;i++)(*iloc)[i] = 0;
   for(j=0;j<ntarg;j++){
     // determine which box this pollint will go llinto.
     ixh = (llint) floor(xtarg[j]/h);
     if(ixh > nside -1)ixh = nside - 1;
     if(ixh < 0)ixh = 0;
     iadr = ixh;
     if ((*iloc)[iadr]==0) {
       (*iloc)[iadr] = *ntbox;
       (*ntbox) += 1;
     }
   }
   *locexp = (lldouble**) malloc(*ntbox * sizeof(lldouble*));
   for(i = 0; i < *ntbox; i++)(*locexp)[i] = (lldouble*) malloc((nterms+1) * sizeof(lldouble));
   return;
}
 
 lldouble scale_to_cube(lldouble* sx,llint NX){
   llint i;
   lldouble maxx = -INF;
   lldouble minx = INF;
   lldouble scale;
   for(i = 0; i < NX; i++) {
     maxx = dmax(maxx, sx[i]);
     minx = dmin(minx, sx[i]);
   }
   scale = maxx - minx;
   for(i = 0; i < NX; i++) sx[i] = (sx[i] - minx)/scale;
   sourcescale = scale;
   return scale;
 }
 
 void allocate(int NX){
   sgx = (lldouble*) malloc(NX * sizeof(lldouble));
   
 }



 
 void gaussth1(lldouble *w, lldouble kparams,llint NX, lldouble* bests, lldouble eps_abs,int IRC) {
   lldouble scale = scale_to_cube(sgx,NX);
   gausst(sgx,w,NX,bests,((kparams*kparams)/(scale*scale)),eps_abs,IRC);
 }
 void gaussth2(lldouble *w, lldouble kparams,llint NX, lldouble* bests, lldouble eps_abs,int IRC) {
   lldouble scale = sourcescale;
   gausst(sgx,w,NX,bests,((kparams*kparams)/(scale*scale)),eps_abs,IRC);
 }
 
 

};


#undef INF
//#undef IRC
#undef K1
#undef NE
#undef PI
